<template>
  <div>
    <!-- <el-button @click="reload">reload test</el-button>
    <el-button @click="connect">connect test</el-button> -->
    <video v-if="isTeacher" controls width="100%" ref="myVideo"/>
    <video v-if="!isTeacher" controls width="100%" ref="teacherVideo"/>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';

export default {
  name: 'RealtimeWebcamLecture',
  props: ['lecture_id'],
  data() {
    return {
      // webRTC
      pc: [],
      offer: [],
      configuration: {
        iceServers: [
          {
            urls: 'stun:stun.l.google.com:19302',
          },
        ],
      },
      hasVideo: false, // 접속자 시스템에 비디오, 오디오 여부
      hasAudio: false,
      userList: [],
      localStream: undefined,
      roomNumber: undefined,
      trackStackCount: 0,
    };
  },
  async mounted() {
    console.log('@SGroupRoom2');
    const vm = this;
    
    console.log('vm.$socket = ', vm.$socket);
    vm.roomNumber = vm.discussionRoomId;

    // 강사라면, 본인 화면 준비
    if (vm.isTeacher) {
      vm.localStream = await navigator.mediaDevices.getUserMedia({
        audio: true,
        video: { frameRate: { ideal: 60, max: 60 }, width: 1280, height: 720 },
      });
      vm.$refs.myVideo.srcObject = vm.localStream;
      vm.trackStackCount = 2;
      vm.$refs.myVideo.play();
    }

    // 입장 사실 서버에 알림
    vm.$socket.emit('DISCUSSION2' , JSON.stringify({
      join: true,
      discussion_room_id: vm.discussionRoomId,
      user_id: utils.getUserIdFromJwt(),
      type: utils.getAuthTypeFromJwt2(),
      lecture_id: vm.lecture_id,
    }));
    console.log('after join');
    console.log('vm.discussionRoomId = ', vm.discussionRoomId);
    console.log('utils.getUserIdFromJwt() = ', utils.getUserIdFromJwt());
    console.log('utils.getAuthTypeFromJwt2() = ', utils.getAuthTypeFromJwt2());


    vm.sockets.subscribe('DISCUSSION2', async (evt) => {
      console.log('@DISCUSSION2');
      const signal = JSON.parse(evt);

      // 디버깅용 내 정보 표시 목적
      if (signal.debug) {
        console.log('socket_id = ', signal.socket_id);
        console.log('node_number = ', signal.node_number);
        return;
      }
    
      // 이미 연결된적이 있는 유저인지 찾는다.
      let userIndex = -1;
      vm.userList.forEach((element, index) => {
        // if (element.email_id === signal.from_email_id) {
        if (element.socket_id === signal.from_socket_id) {
          userIndex = index;
        }
      })
      // 만약 저장되지 않았다면, 저장하고 인덱스를 리턴한다.
      if (userIndex === -1) {
        // vm.userList.push({ email_id: signal.from_email_id });
        vm.userList.push({ socket_id: signal.from_socket_id });
        userIndex = vm.userList.length - 1;
      }

      if (signal.child_socket_id) { // 자식 소켓에 연결하라는 명령 받은 경우
        console.log(userIndex, ': on child_socket_id');
        vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);

        while (vm.localStream === undefined && vm.trackStackCount !== 2) {
          await new Promise(r => setTimeout(r, 1000));
          console.log('vm.localStream = ', vm.localStream);
          console.log('localStream 확보를 기다리는 중입니다...');
        }

        vm.localStream.getTracks().forEach(track => {
          vm.pc[userIndex].addTrack(track, vm.localStream);
        });

        const offer = await vm.pc[userIndex].createOffer();
        vm.offer[userIndex] = offer;

        console.log('offer = ', offer);

        // Listen for local ICE candidates on the local RTCPeerConnection
        vm.pc[userIndex].addEventListener('icecandidate', event => {
          if (event.candidate) {
            vm.$socket.emit('DISCUSSION2', JSON.stringify({
              candidate: event.candidate,
              to_socket_id: signal.from_socket_id,
            }));
            console.log(userIndex, ': emit icecandidate');
          }
        });

        vm.pc[userIndex].addEventListener('connectionstatechange', event => {
          if (vm.pc[userIndex].connectionState === 'connected') {
            console.log(userIndex, ': peer connected!');
          }
          if (vm.pc[userIndex].connectionState === 'disconnected') {
            console.log(userIndex, ': peer disconnected!');
            vm.userList.splice(userIndex, 1);
          }
        });

        vm.$socket.emit('DISCUSSION2' , JSON.stringify({
          to_socket_id: signal.child_socket_id,
          offer,
        }));
        console.log(userIndex, ': emit offer');
      }
      if (signal.offer) {
        
        console.log(userIndex, ': on offer');
        vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);

        // Listen for local ICE candidates on the local RTCPeerConnection
        vm.pc[userIndex].addEventListener('icecandidate', event => {
          if (event.candidate) {
            vm.$socket.emit('DISCUSSION2', JSON.stringify({
              candidate: event.candidate,
              to_socket_id: signal.from_socket_id,
            }));
            console.log(userIndex, ': emit icecandidate');
          }
        });

        vm.pc[userIndex].addEventListener('connectionstatechange', event => {
          if (vm.pc[userIndex].connectionState === 'connected') {
            console.log(userIndex, ': peer connected!');
            vm.$refs.teacherVideo.play(); // TODO:: 여기가 최선인지 모르겠지만 잘 작동하므로 넣어둠..
          }
          else if (vm.pc[userIndex].connectionState === 'disconnected') {
            console.log(userIndex, ': peer disconnected!');
            vm.userList.splice(userIndex, 1);
            console.log('상위 노드 접속 끊어짐');
            vm.leaveRoom();
            vm.$notify({
              title: '알림',
              message: '상위 노드 접속 끊어짐. 화면을 새로고침합니다.',
              type: 'warning',
            });
            // location.reload();
            vm.$emit('reloadSGroupRoom2');
          } else {
            console.log('vm.pc[userIndex].connectionState = ', vm.pc[userIndex].connectionState);
            console.log('event = ', event);
          }
        });

        const remoteStream = new MediaStream();
        console.log('vm.$refs = ', vm.$refs);
        console.log('vm.$refs.teacherVideo = ', vm.$refs.teacherVideo);
        vm.$refs.teacherVideo.srcObject = remoteStream;
        vm.pc[userIndex].addEventListener('track', async (event) => {
          console.log(userIndex, ': @get remoteStream ☆');
          remoteStream.addTrack(event.track, remoteStream);
          vm.localStream = remoteStream;
          vm.trackStackCount += 1;
        });
        
        vm.pc[userIndex].setRemoteDescription(new RTCSessionDescription(signal.offer));
        const answer = await vm.pc[userIndex].createAnswer();
        await vm.pc[userIndex].setLocalDescription(answer);
        
        console.log(userIndex, '@on offer / candidate 수신 준비됨');
        vm.userList[userIndex].candidateReadyStatus = true;

        vm.$socket.emit('DISCUSSION2', JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          from_name: utils.getNameFromJwt(),
          answer,
        }));
        console.log(userIndex, ': emit answer');
      }
      if (signal.answer) {
        console.log(userIndex, ': on answer');
        const remoteDesc = new RTCSessionDescription(signal.answer);
        await vm.pc[userIndex].setLocalDescription(vm.offer[userIndex]);
        await vm.pc[userIndex].setRemoteDescription(remoteDesc);
        console.log(userIndex, '@on answer / candidate 수신 준비됨');
        vm.userList[userIndex].candidateReadyStatus = true;
      }
      if (signal.candidate) {
        while (vm.userList[userIndex].candidateReadyStatus !== true) {
          await new Promise(r => setTimeout(r, 1000));
          console.log('candidate 수신 준비가 완료되지 않아 대기하는 중입니다...');
        }
        try {
          console.log(userIndex, ' : add icecandidate');
          await vm.pc[userIndex].addIceCandidate(signal.candidate);
        } catch (e) {
          console.log(userIndex, ': Error adding received ice candidate');
          console.log('e = ', e);
        }
      }
    });
  },
  methods: {
    leaveRoom() {
      const vm = this;

      vm.$socket.emit('DISCUSSION2', JSON.stringify({
        leave: true,
        discussion_room_id: vm.roomNumber,
      }));

      if (vm.localStream) {
        vm.localStream.getTracks().forEach((track) => { // 비디오, 오디오 수집 중지
          track.stop();
        })
      }

      vm.pc.forEach((pc) => { // pc 연결 해제
        pc.close();
      })

      // //vm.$socket.close(); // 소켓 연결 해제
    },
  },
  computed: {
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
    isTeacher() {
      const vm = this;
      return utils.getAuthTypeFromJwt2() === 1;
    }
  },
  async beforeDestroy() {
    console.log('@beforeDestroy');
    const vm = this;
    vm.leaveRoom();
  }, 
};
</script>